#!/bin/sh

#===========================================================================
#== Adres IP serwera Zabbix ===========================
ZABBIX_SERVER="xxx.xxx.xxx.xxx"
#== Nazwa hosta na serwerze Zabbix ====================
HOST="liw01"
# == Link bezpośredni z serwera SUPLA (json) ==========
SUPLA_LINK_LIW="https://.........=json"
# == Rozliczanie minutowe =============================
# >> rminute=1 - aktywne
rminute=0
# == Rozliczanie godzinowe ============================
# >> rhour=1 - aktywne 
rhour=0
#===========================================================================
x_true="true"
NAZ0="/var/local/"$HOST"_"
NAZ3="/tmp/"$HOST".txt"
#===========================================================================
FILE=$NAZ0"dailytime.txt"
if ! [ -f "$FILE" ]; then
  echo "2355" > $FILE
  detime=2355
else
  detime=`cat $FILE`
  if [ $detime -ne 2355 -a $detime -ne 2356 -a $detime -ne 2357 -a $detime -ne 2358 ]; then
    echo "2355" > $FILE
    detime=2355
  fi
fi
#===========================================================================
FILE=$NAZ0"hourlytime.txt"
if ! [ -f "$FILE" ]; then
  hetime="`date +"%H"`"
  echo "$hetime" > $FILE
else
  hetime=`cat $FILE`
fi
#===========================================================================
OUTPUT=$(curl -k "$SUPLA_LINK_LIW")
x_connected=`echo $OUTPUT | jq '.connected'`
if [ "$x_connected" = "$x_true" ]; then
  x_totalCost=`echo $OUTPUT | jq '.totalCost'`
  x_pricePerUnit=`echo $OUTPUT | jq '.pricePerUnit'`
  x_impulsesPerUnit=`echo $OUTPUT | jq '.impulsesPerUnit'`
  x_counter=`echo $OUTPUT | jq '.counter'`
  x_calculatedValue=`echo $OUTPUT | jq '.calculatedValue'`
  x_currency=`echo $OUTPUT | jq '.currency'`
  x_unit=`echo $OUTPUT | jq '.unit'`
  if [ $rminute -eq 1 ]; then
    FILE=$NAZ0"minuteenergy.txt"
    if [ -f "$FILE" ]; then
      x_minuteenergy=`cat $FILE`
    else
      x_minuteenergy=`echo $x_calculatedValue \* 1000 | bc`
      echo "$x_minuteenergy" > $FILE
    fi
    x_calculatedValue1=`echo $x_calculatedValue \* 1000 | bc`
    x_minuteenergy=`echo $x_calculatedValue1 - $x_minuteenergy | bc`
    x_minutecost=`echo $x_pricePerUnit \* $x_minuteenergy | bc`
  fi
  echo "$x_calculatedValue1" > $FILE
  echo "$HOST ttc $x_totalCost" > $NAZ3
  echo "$HOST ppu $x_pricePerUnit" >> $NAZ3
  echo "$HOST ipu $x_impulsesPerUnit" >> $NAZ3
  echo "$HOST cnt $x_counter" >> $NAZ3
  echo "$HOST ccv $x_calculatedValue" >> $NAZ3
  echo "$HOST cur $x_currency" >> $NAZ3
  echo "$HOST unit $x_unit" >> $NAZ3
  if [ $rminute -eq 1 ]; then
    echo "$HOST menerg $x_minuteenergy" >> $NAZ3
    echo "$HOST mcost $x_minutecost" >> $NAZ3
  fi
  zabbix_sender -z "$ZABBIX_SERVER" -i $NAZ3 > /dev/null
fi
#===========================================================================

#===========================================================================
#=== ROZLICZENIE GODZINOWE =================================================
#===========================================================================
if [ $rhour -eq 1 ]; then
  DATAH="`date +"%H"`"
  DATAM="`date +"%M"`"
  if [ $DATAH -ne $hetime -a $DATAM -eq 00 ]; then
    if [ "$x_connected" = "$x_true" ]; then
      x_calculatedValue1=`echo $x_calculatedValue \* 1000 | bc`
      FILE=$NAZ0"hourlyenergy.txt"
      if [ -f "$FILE" ]; then
        x_hourlyenergy=`cat $FILE`
        x_hourlyenergy=`echo $x_calculatedValue1 - $x_hourlyenergy | bc`
        x_hourlycost=`echo $x_pricePerUnit \* $x_hourlyenergy | bc`
        echo "$x_calculatedValue1" > $FILE
        echo "$HOST henerg $x_hourlyenergy" > $NAZ3
        echo "$HOST hcost $x_hourlycost" >> $NAZ3
        #======================================================
        zabbix_sender -z "$ZABBIX_SERVER" -i $NAZ3 > /dev/null
        #======================================================
        echo "$hetime" > $NAZ0"hourlytime.txt"
      else
        echo "$x_calculatedValue1" > $FILE
      fi
    fi
  fi
fi
#===========================================================================

#===========================================================================
#=== BILANS DNIA o 23.55 ===================================================
#===========================================================================
DATA="`date +"%H%M"`"
if [ $DATA -eq $detime ]; then
  if [ "$x_connected" = "$x_true" ]; then
    #=== Energia dzienna pobrana ===========================================
    x_calculatedValue1=`echo $x_calculatedValue \* 1000 | bc`
    FILE=$NAZ0"dailyenergy.txt"
    if [ -f "$FILE" ]; then
      x_dailyenergy=`cat $FILE`
      x_dailyenergy=`echo $x_calculatedValue1 - $x_dailyenergy | bc`
      x_dailycost=`echo $x_pricePerUnit \* $x_dailyenergy | bc`
      echo "$x_calculatedValue1" > $FILE
      echo "$HOST denerg $x_dailyenergy" > $NAZ3
      echo "$HOST dcost $x_dailycost" >> $NAZ3
      #======================================================
      zabbix_sender -z "$ZABBIX_SERVER" -i $NAZ3 > /dev/null
      #======================================================
      detime=2355
      echo "$detime" > $NAZ0"dailytime.txt"
    else
      echo "$x_calculatedValue1" > $FILE
    fi
  else
    #==============================================================
    # Brak danych z serwera SUPLA
    #==============================================================
    detime=`echo  $detime + 1 | bc`
    if [ $detime -eq 2359 ]; then
      detime=2355
    fi
    echo "$detime" > $NAZ0"dailytime.txt"
  fi
fi
#===========================================================================
